###############################################################################
# Post.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$postplver = "1 Gold - SP 1.1";

sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	my($filetype_info, $filesize_info);
	my( $subtitle, $x, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msubject, $mattach, $mip, $mmessage, $mns, $quotestart);
	my $quotemsg = $INFO{'quote'};
	$threadid = $INFO{'num'};

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msummary) = split(/\|/,$yyThreadLine);
	if( $mstate == 1 ) { &fatal_error($txt{'90'}); }

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	$curcat = $cat;
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	$pollthread = 0;
	$polltxt{'1a'} =~ tr/+/ /;
	$polltxt{'2a'} =~ tr/+/ /;
	if ($INFO{'title'} eq $polltxt{'1a'}) { $pollthread = 1; }
	elsif ($INFO{'title'} eq $polltxt{'2a'}) { $pollthread = 2; }
	if ($pollthread == 2 && $useraddpoll == 0) { &fatal_error($txt{'1'}); }

	$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;

	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><font size="2"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></font></td>
      </tr>~ : qq~~;

	$sub = "";
	$settofield="subject";
	if( $threadid ne '' ) {
		fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("201 $txt{'106'}: $txt{'23'} $threadid.txt");
		@messages = <FILE>;
		fclose(FILE);

		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
			$message=$mmessage;
			$message =~ s~<br>~\n~g;
			$message =~ s~\n{0,1}\[quote([^\]]*)\](.*?)\[/quote\]\n{0,1}~\n~isg;
			$message =~ s~\n*\[/*quote([^\]]*)\]\n*~~ig;

			$mname ||= $musername || $txt{'470'};
			$quotestart = int( $quotemsg / $maxmessagedisplay ) * $maxmessagedisplay;
			$message = qq~[quote author=$mname link=board=$currentboard;num=$threadid;start=$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
			$msubject =~ s/\bre:\s+//ig;
			if ($mns eq "NS") {$nscheck="checked";}
		}
		else {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage, $mns) = split(/\|/,$messages[0]);
			$msubject =~ s/\bre:\s+//ig;
		}
		$sub = "Re: $msubject";
		$settofield="message";
	}
	if ($pollthread && $username eq "Guest") {$guest_vote = 1;}
	if ($pollthread == 2) {
		$settofield="question";
		$sub = "$msubject";
	} else {
		if (!$enable_notification || $username eq 'Guest') {$notification = ""} else { $notification = qq~<tr>
                <td><font size="2"><b>$txt{'131'}:</b></font></td>
                <td><input type="checkbox" name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
              </tr>~;}
	}
	if(!$sub) { $subtitle = "<i>$txt{'33'}</i>"; }
	else { $subtitle = "<i>$sub</i>"; }
	$yymain .= qq~
<table  width="90%" align="center" cellpadding=0 cellspacing=0>
  <tr>
    <td valign=bottom colspan="2">
    <font size=2 class="nav"><B><img src="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border=0><IMG SRC="$imagesdir/open.gif"  border=0>&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border=0><IMG SRC="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a><br>
    <img SRC="$imagesdir/tline3.gif" border=0><IMG SRC="$imagesdir/open.gif" border=0>&nbsp;&nbsp;
    $INFO{'title'} ( $subtitle )</td>
  </tr>
</table>
~;
	$submittxt = "$txt{'105'}";
	$destination = "post2";
	$icon = "xx";
	$waction = "post";
	$post = "post";
	$preview = "preview";
	$yytitle = "$INFO{'title'}";
	&Postpage;
	if ($pollthread != 2) { &doshowthread; }
	&template;
	exit;
}

sub Postpage {
## [Extra Message Fields] ##
	if (-e("$boardsdir/$currentboard.xtra")) {require "$boardsdir/$currentboard.xtra";}
	if ($xhubbc eq "1") {$showyabbcbutt = 0;}
	if ($xhsmilies eq "1") {$showadded = 0; $showsmdir = 0;}
	if ($xhattach eq "1") {$allowattach = 0;}

	$subjectxtra = "";
	$messagextra = "";
	if ($action eq 'post' || $action eq 'post2') {
		if ($xtraformats ne '0' && $xtraopts ne "" && $threadid eq '') {
			@xoptions = split(/\|/, $xtraopts);
			$subjectxtra .= qq~<tr>\n~;
			$subjectxtra .= qq~        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$xtraheadings:</b></font></td>\n~;
			$subjectxtra .= qq~        <td class="windowbg" bgcolor="$color{'windowbg'}"><select name="field0" size="1">\n~;
			$i = 0;
			foreach $xtmp (@xoptions) {
				if ($field[0] eq $xtmp) {$selected=" selected";} else {$selected = "";}
				$subjectxtra .= qq~<option value="$i"$selected>$xtmp</option>~;
				$i++;
			}
			$subjectxtra .= qq~</td>\n      </tr>\n~;
		}

		if ($xtraformat ne '0' && $xtraopt ne "" && ($xtrareply eq "1" || ($xtrareply eq "0" && $threadid eq ''))) {
			@xoptions = split(/\|/, $xtraopt);
			$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$xtraheading:</b></font></td>\n~;
			$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="field1" size="1">~;
			$i = 0;
			foreach $xtmp (@xoptions) {
				if ($field[1] eq $xtmp) {$selected=" selected";} else {$selected = "";}
				$messagextra .= qq~<option value="$i"$selected>$xtmp</option>~;
				$i++;
			}
			$messagextra .= qq~</td>\n      </tr><tr>\n~;
		}
		if ($xtraformat ne '0' && $xtrafield ne "" && ($xtrareply eq "1" || ($xtrareply eq "0" && $threadid eq ''))) {
			@xfields = split(/\|/, $xtrafield);
			$i = 2;
			foreach $xtmp (@xfields) {
				$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$xtmp:</b></font></td>\n~;
				$messagextra .= qq~        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><input type="text" name="field$i" value="$field[$i]" size="60" maxlength="60"></font></td>\n~;
				$messagextra .= qq~      </tr><tr>\n~;
				$i++;
			}
		}
	}
## [/Extra Message Fields] ##

	my $extra;
	my($filetype_info, $filesize_info);
	$filetype_info = $checkext == 1 ? qq~$fatxt{'2'} @ext~ : qq~$fatxt{'2'} $fatxt{'4'}~;
	$filesize_info = $limit != 0 ? qq~$fatxt{'3'} $limit KB~ : qq~$fatxt{'3'} $fatxt{'5'}~;
	if ($FORM{'waction'} =~ /preview/) {$txt{'507'}=$txt{'771'};}
	if($MaxSumLen > "0" && ((($action eq 'post' || $action eq 'post2') && $threadid eq '') || (($action eq 'modify' || $action eq 'modify2') && $postid eq '0'))) {
		$summary_field = qq~      <tr>
        <td valign="top" class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size="2"><b>$mitstxt{'1'}:</b></font><br><font size="1">$MaxSumLen $mitstxt{'2'}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size="2"><textarea name="summary" rows="2" cols="60" wrap="soft"  onkeyup="if (document.postmodify.summary.value.length > $MaxSumLen) {document.postmodify.summary.value = document.postmodify.summary.value.substring(0,$MaxSumLen)}">$summary</textarea></font></td>
      </tr>~;
	} else {$summary_field ='';}
	if($waction eq "imsend") {
		if(!$INFO{'to'}) { $INFO{'to'} = $FORM{'to'};}
		if($INFO{'to'}) {$settofield="message";} else {$settofield="to";}
		$idinfo = "$INFO{'id'}";
if(!$INFO{'adminim'}) {
		$extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'150'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
	<input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50" tabindex="2">
	<font size="1">$txt{'748'}</font></td>
      </tr>
	~;
} else { $extra = qq~$adminim~; }

	}
	elsif ($xhicon eq "1") {$extra = qq~<input type="hidden" name="icon" value="xx">~;}
	else {
	 $extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'71'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
        <select name="icon" onChange="showimage()">
         <option value="xx"$ic1>$txt{'281'}
         <option value="thumbup"$ic2>$txt{'282'}
         <option value="thumbdown"$ic3>$txt{'283'}
         <option value="exclamation"$ic4>$txt{'284'}
         <option value="question"$ic5>$txt{'285'}
         <option value="lamp"$ic6>$txt{'286'}
         <option value="smiley"$ic7>$txt{'287'}
         <option value="angry"$ic8>$txt{'288'}
         <option value="cheesy"$ic9>$txt{'289'}
         <option value="laugh"$ic10>$txt{'290'}
         <option value="sad"$ic11>$txt{'291'}
         <option value="wink"$ic12>$txt{'292'}
        </select>
        <img src="$imagesdir/$icon.gif" name="icons" border=0 hspace=15></td>
      </tr>
	 ~;
	if ($realname eq '' && $threadid ne '') {$settofield="name";}
	}
	$yymain .= qq~
<table border=0 width="90%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'bordercolor'}">
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
~; 

 $moresmilieslist = ""; 
 $more_smilie_array = ""; 
 $i=0; 
 if ($showadded eq 1){
 while($SmilieURL[$i]) { 
  if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$imagesdir/$SmilieURL[$i]~;}
  $moresmilieslist .= qq~      document.write("<img src='$tmpurl' align=bottom alt="+'"'+"$SmilieDescription[$i]"+'"'+" border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
  $tmpcode = $SmilieCode[$i];
  $tmpcode =~ s/\&quot;/"+'"'+"/g;
  &FromHTML($tmpcode);
  $tmpcode =~ s/&#36;/\$/g;
  $tmpcode =~ s/&#64;/\@/g;
  $more_smilie_array .= qq~" $tmpcode", ~; 
  $i++; 
 } 
}
if ($showsmdir eq 1){
 opendir(DIR, "$smiliesdir"); 
  @contents = readdir(DIR); 
 closedir(DIR); 
 foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
  ($name, $extension) = split (/\./, $line); 
  if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
   if ($line !~ /banner/i) { 
    $moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
    $more_smilie_array .= qq~" [smiley=$line]", ~; 
    $i++ 
   } 
  } 
 } 
 }
 $more_smilie_array .= qq~""~; 
 
 $yymain .= qq~ 
 moresmiliecode = new Array($more_smilie_array) 
 
 function MoreSmilies(i) { 
  AddTxt=moresmiliecode[i]; 
  AddText(AddTxt); 
 }  

~;
if ($smiliestyle eq 1){
	$smiliewinlink = "$scripturl?action=smilieput";
}
else{
	$smiliewinlink = "$scripturl?action=smilieindex";
}
$yymain .= qq~
function smiliewin() {
  window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
}

function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>~;
if($INFO{'adminim'} || $INFO{'action'} eq "imgroups") {
$yymain .= qq~<form action="$cgi;action=imgroups" method="post" name="postmodify"  ENCTYPE="multipart/form-data" onSubmit="submitonce(this);">~;
} else {
$yymain .= qq~<form action="$cgi;action=$destination" method="post" name="postmodify"  ENCTYPE="multipart/form-data" onSubmit="submitonce(this);">~;
}
$yymain .= qq~
    <input type="hidden" name="threadid" value="$threadid">
    <input type=hidden name="postid" value="$postid">
    <input type=hidden name="info" value="$idinfo">
    <table class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
      <tr>
        <td><font size=2 class="text1" color="$color{'titletext'}"><b>$yytitle</b></font></td>
      </tr>
    </table>
    </td>
  </tr>~;
	if ($pollthread != 2 || ($pollthread == 2 && $username eq 'Guest')) { $yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">~;
		if ($pollthread == 2 ) {$extra = "";} else { $yymain .= qq~
$subjectxtra
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'70'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><input type=text name="subject" value="$sub" size="40" maxlength="50" tabindex="1"></font></td>
      </tr>
~;
		}
		$yymain .= qq~
$name_field
$email_field
$extra
$summary_field
    </table>
    </td>
   </tr>
~;
	}

## [Poll Mod Options] ##
	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		if ($guest_vote) {$gvchecked = " checked";}
		if ($hide_results) {$hrchecked = " checked";}
		if ($multi_choice) {$mcchecked = " checked";}
		$yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg2'}" class="windowbg2">
            <input type="hidden" name="pollthread" value="$pollthread">
            <table width="100%" cellpadding="3" cellspacing="0" border="0">
              <tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'6'}:</b></font></td>
                <td align="left"><input type="text" size="40" name="question" value="$poll_question" maxlength="$maxpq"></td>
              </tr><tr>
                <td width="23%" align="left">&nbsp;</td>
                <td align="left">
                  <table cellpadding="0" cellspacing="0" border="0">~;

		for(my $i = 1; $i <= $numpolloptions; $i++) {
			$yymain .= qq~
                    <tr>
                      <td align="right"> &nbsp; <font size="2">$polltxt{'7'} $i: &nbsp;</font></td>
                      <td align="left"><input type="text" size="25" maxlength="$maxpo" name="option$i" value="$options[$i]"></td>
                    </tr>~;
		}
		$yymain .= qq~
                  </table>
                </td>~;

		if ($maxpc > 0) {
			$yymain .= qq~
             </tr><tr>
                <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$polltxt{'59'}:</b></font></td>
                <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></font></td>~;
		}

		$yymain .= qq~
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'32'}</b></font></td>
                <td align="left"><input type="checkbox" name="guest_vote" value="1"$gvchecked> <font size="1">$polltxt{'54'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'26'}</b></font></td>
                <td align="left"><input type="checkbox" name="hide_results" value="1"$hrchecked> <font size="1">$polltxt{'55'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'58'}</b></font></td>
                <td align="left"><input type="checkbox" name="multi_choice" value="1"$mcchecked> <font size="1">$polltxt{'56'}</font></td>
              </tr>

            </table>
          </td>
        </tr>~;
	}
	if ($pollthread != 2) { # if not adding a poll to an existing thread, display standard post page inputs

## [/Poll Mod Options] ##

if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg2'}" class="windowbg2">
      <tr>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'252'}:</b></font></td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3)) {
          document.write("<a href=javascript:bold()><img src='$imagesdir/bold.gif' align=bottom width=23 height=22 alt='$txt{'253'}' border=0></a>");
          document.write("<a href=javascript:italicize()><img src='$imagesdir/italicize.gif' align=bottom width=23 height=22 alt='$txt{'254'}' border='0'></a>");
          document.write("<a href=javascript:underline()><img src='$imagesdir/underline.gif' align=bottom width=23 height=22 alt='$txt{'255'}' border='0'></a>");
          document.write("<a href=javascript:strike()><img src='$imagesdir/strike.gif' align=bottom width=23 height=22 alt='$txt{'441'}' border='0'></a>");
          document.write("<a href=javascript:glow()><img src='$imagesdir/glow.gif' align=bottom width=23 height=22 alt='$txt{'442'}' border='0'></a>");
          document.write("<a href=javascript:shadow()><img src='$imagesdir/shadow.gif' align=bottom width=23 height=22 alt='$txt{'443'}' border='0'></a>");
          document.write("<a href=javascript:move()><img src='$imagesdir/move.gif' align=bottom width=23 height=22 alt='$txt{'439'}' border='0'></a>");
          document.write("<a href=javascript:pre()><img src='$imagesdir/pre.gif' align=bottom width=23 height=22 alt='$txt{'444'}' border='0'></a>");
          document.write("<a href=javascript:left()><img src='$imagesdir/left.gif' align=bottom width=23 height=22 alt='$txt{'445'}' border='0'></a>");
          document.write("<a href=javascript:center()><img src='$imagesdir/center.gif' align=bottom width=23 height=22 alt='$txt{'256'}' border='0'></a>");
          document.write("<a href=javascript:right()><img src='$imagesdir/right.gif' align=bottom width=23 height=22 alt='$txt{'446'}' border='0'></a>");
          document.write("<a href=javascript:hr()><img src='$imagesdir/hr.gif' align=bottom width=23 height=22 alt='$txt{'531'}' border='0'></a>");
          document.write("<a href=javascript:size()><img src='$imagesdir/size.gif' align=bottom width=23 height=22 alt='$txt{'532'}' border='0'></a>");
          document.write("<a href=javascript:font()><img src='$imagesdir/face.gif' align=bottom width=23 height=22 alt='$txt{'533'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        <select name="color" onChange="showcolor(this.options[this.selectedIndex].value)">
         <option value="Black" selected>$txt{'262'}</option>
         <option value="Red">$txt{'263'}</option>
         <option value="Yellow">$txt{'264'}</option>
         <option value="Pink">$txt{'265'}</option>
         <option value="Green">$txt{'266'}</option>
         <option value="Orange">$txt{'267'}</option>
         <option value="Purple">$txt{'268'}</option>
         <option value="Blue">$txt{'269'}</option>
         <option value="Beige">$txt{'270'}</option>
         <option value="Brown">$txt{'271'}</option>
         <option value="Teal">$txt{'272'}</option>
         <option value="Navy">$txt{'273'}</option>
         <option value="Maroon">$txt{'274'}</option>
         <option value="LimeGreen">$txt{'275'}</option>
        </select>
        <br>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3)) {
          document.write("<a href=javascript:flash()><img src='$imagesdir/flash.gif' align=bottom width=23 height=22 alt='$txt{'433'}' border='0'></a>");
          document.write("<a href=javascript:hyperlink()><img src='$imagesdir/url.gif' align=bottom width=23 height=22 alt='$txt{'257'}' border='0'></a>");
          document.write("<a href=javascript:ftp()><img src='$imagesdir/ftp.gif' align=bottom width=23 height=22 alt='$txt{'434'}' border='0'></a>");
          document.write("<a href=javascript:image()><img src='$imagesdir/img.gif' align=bottom width=23 height=22 alt='$txt{'435'}' border='0'></a>");
          document.write("<a href=javascript:emai1()><img src='$imagesdir/email2.gif' align=bottom width=23 height=22 alt='$txt{'258'}' border='0'></a>");
          document.write("<a href=javascript:table()><img src='$imagesdir/table.gif' align=bottom width=23 height=22 alt='$txt{'436'}' border='0'></a>");
          document.write("<a href=javascript:trow()><img src='$imagesdir/tr.gif' align=bottom width=23 height=22 alt='$txt{'437'}' border='0'></a>");
          document.write("<a href=javascript:tcol()><img src='$imagesdir/td.gif' align=bottom width=23 height=22 alt='$txt{'449'}' border='0'></a>");
          document.write("<a href=javascript:superscript()><img src='$imagesdir/sup.gif' align=bottom width=23 height=22 alt='$txt{'447'}' border='0'></a>");
          document.write("<a href=javascript:subscript()><img src='$imagesdir/sub.gif' align=bottom width=23 height=22 alt='$txt{'448'}' border='0'></a>");
          document.write("<a href=javascript:teletype()><img src='$imagesdir/tele.gif' align=bottom width=23 height=22 alt='$txt{'440'}' border='0'></a>");
          document.write("<a href=javascript:showcode()><img src='$imagesdir/code.gif' align=bottom width=23 height=22 alt='$txt{'259'}' border='0'></a>");
          document.write("<a href=javascript:quote()><img src='$imagesdir/quote2.gif' align=bottom width=23 height=22 alt='$txt{'260'}' border='0'></a>");
          document.write("<a href=javascript:list()><img src='$imagesdir/list.gif' align=bottom width=23 height=22 alt='$txt{'261'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
      <tr>
        <td bgcolor="$color{'bordercolor'}" colspan="2">
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
~;
}
if ($xhsmilies ne "1") {
	$yymain .= qq~
      <tr>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'297'}:</b></font></td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
          document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align=bottom alt='$txt{'287'}' border='0'></a> ");
          document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align=bottom alt='$txt{'292'}' border='0'></a> ");
          document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align=bottom alt='$txt{'289'}' border='0'></a> ");
          document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align=bottom alt='$txt{'293'}' border='0'></a> ");
          document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align=bottom alt='$txt{'288'}' border='0'></a> ");
          document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align=bottom alt='$txt{'291'}' border='0'></a> ");
          document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align=bottom alt='$txt{'294'}' border='0'></a> ");
          document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align=bottom alt='$txt{'295'}' border='0'></a> ");
          document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align=bottom alt='$txt{'296'}' border='0'></a> ");
          document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align=bottom alt='$txt{'450'}' border='0'></a> ");
          document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align=bottom alt='$txt{'451'}' border='0'></a> ");
          document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align=bottom alt='$txt{'526'}' border='0'></a> ");
          document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align=bottom alt='$txt{'527'}' border='0'></a> ");
          document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align=bottom alt='$txt{'528'}' border='0'></a> ");
          document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align=bottom alt='$txt{'529'}' border='0'></a> ");
          document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align=bottom alt='$txt{'530'}' border='0'></a> ");
$moresmilieslist
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
~;
if (($showadded == 3 && $showsmdir ne 2) || ($showsmdir eq 3 && $showadded ne 2)){
	$yymain .= qq~
<a href=javascript:smiliewin()>$smiltxt{'1'}</a>
~;
}
$yymain .= qq~ 

        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr><tr>
~;
	}
$yymain .= qq~
$messagextra
        <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'72'}:</b></font>
        <br><br>
	~;
		if ($showadded eq 2 || $showsmdir eq 2){ 
	$yymain .= qq~
        <script language="JavaScript1.2" type="text/javascript">
        <!--
          function Smiliextra() {
            AddTxt=smiliecode[document.postmodify.smiliextra_list.value];
            AddText(AddTxt);
          }
	~;

	$smilieslist = "";
	$smilie_url_array = "";
	$smilie_code_array = "";
	$i=0;
	if ($showadded eq 2){
	while($SmilieURL[$i]) {
		$smilieslist .= qq~           document.write("<option value='$i'>$SmilieDescription[$i]");\n~;
		if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$imagesdir/$SmilieURL[$i]~;}
		$smilie_url_array .= qq~"$tmpurl", ~;
		$tmpcode = $SmilieCode[$i];
		$tmpcode =~ s/\&quot;/"+'"'+"/g;
  		&FromHTML($tmpcode);
  		$tmpcode =~ s/&#36;/\$/g;
  		$tmpcode =~ s/&#64;/\@/g;
		$smilie_code_array .= qq~" $tmpcode", ~;
		$i++;
	}
	}
	if ($showsmdir eq 2){
	opendir(DIR, "$smiliesdir");
		@contents = readdir(DIR);
	closedir(DIR);
	foreach $line (sort {uc($a) cmp uc($b)} @contents){
		($name, $extension) = split (/\./, $line);
		if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){
			if ($line !~ /banner/i) {
				$smilieslist .= qq~           document.write("<option value='$i'>$name");\n~;
				$smilie_url_array .= qq~"$smiliesurl/$line", ~;
				$smilie_code_array .= qq~" [smiley=$line]", ~;
				$i++
			}
		}
	}
	}
	$smilie_url_array .= qq~""~;
	$smilie_code_array .= qq~""~;

	$yymain .= qq~

	smilieurl = new Array($smilie_url_array)
	smiliecode = new Array($smilie_code_array)

        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {

          document.write('<table height="110" width="120" border="0" cellpadding="1" callspacing="3" bgcolor="$color{'bordercolor'}" align="center"><tr>');
          document.write('<td height="20" align="center" valign="top" bgcolor="white"><select name="smiliextra_list" onchange="document.images.smiliextra_image.src= smilieurl[document.postmodify.smiliextra_list.value]" style="width:120px; font-size:7pt">');
$smilieslist
          document.write('</select></td>');
          document.write('</tr><tr>');
          document.write('<td align="center" valign="middle" class="windowbg2" bgcolor="$color{'windowbg2'}"><img name="smiliextra_image" src="'+smilieurl[0]+'" alt="" border="0" onclick="javascript:Smiliextra()" style="cursor:hand"></td>');
          document.write('</tr><tr>');
          document.write('<td height="15" align="center" valign="middle" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1"><a href="javascript:smiliewin()">$smiltxt{'17'}</a></font></td>');
          document.write('</tr></table>');
	}
        //-->
        </script>
        ~;
}
$yymain .= qq~
        </td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">
        <textarea name="message" rows="12" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="4">$message</textarea>
        </font><BR></td>
      </tr>
~;
# File Attachment's Browse Box Code
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top"><font size=2><b>$fatxt{'6'}</b></font></td>
	<td><input type="file" name="file" size="49"></td>
</tr>
<tr>
	<td align="right"></td>
	<td><font size="1">$filetype_info<br>$filesize_info</font></td>
</tr>
~;
if( ($FORM{'waction'} =~ 'preview') && ($FORM{'file'}) ) {
$yymain .= qq~
<tr>
	<td align="right"></td>
	<td><font size="1" color="#FF0000">$fatxt{'7'}</font></td>
</tr>
~;
}

}
# /File Attachment's Browse Box Code
$yymain .= qq~
    </table>
    </td>
~;
	if ($xhcheck ne "1") {
$yymain .= qq~
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
$notification
$lastmod
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'276'}:</b></font><BR><BR></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><input type=checkbox name="ns" value="NS"$nscheck> <font size="1"> $txt{'277'}</font><BR><BR></td>
      </tr>
    </table>
    </td>
~;
	}
$yymain .= qq~
  </tr>~;
	}
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center">
        <font size="1" class="text1" color="$color{'titletext'}"><font size="1">$txt{'329'}</font></font><BR>
		<input type="hidden" name="waction" value="$waction">
		<input type="submit" name="$post" value="$submittxt" onClick="WhichClicked('$post');" accesskey="s" tabindex="5">
~;
unless ($pollthread == 2) {$yymain .= qq~		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">~;}
unless ($FORM{'waction'} =~ /preview/){$yymain .= qq~		<input type="reset" value="$txt{'278'}" accesskey="r">~;}

$yymain.=qq~
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<script language="JavaScript"> <!--
   document.postmodify.$settofield.focus();
//--> </script>
~;
}

sub Preview {
	&clear_temp;
	$poll_question = $FORM{'question'};
	$numpolloptions ||= 8;
	for(my $i = 1; $i <= $numpolloptions; $i++) {$options[$i] = $FORM{"option$i"};}
	$guest_vote = $FORM{'guest_vote'};
	$hide_results = $FORM{'hide_results'};
	$multi_choice = $FORM{'multi_choice'};
	$poll_comment = $FORM{'poll_comment'};
	$pollthread =  $FORM{'pollthread'} || 0;

	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$sub = $FORM{'subject'};
	$summary = $FORM{'summary'};
	$mess = $FORM{'message'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	($xmessage, $xsubject) = &format_extra;
	$message = $xmessage.$message;
	if($INFO{'action'} eq "imgroups") { $destination = "imgroups"; }


	$csubject = $sub;
	if (length($csubject) > 50) { $csubject = substr($csubject,0,50); }
	&ToHTML($csubject);
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	&CheckIcon;

	if($icon eq "xx") { $ic1 = " selected"; }
	elsif($icon eq "thumbup") { $ic2 = " selected"; }
	elsif($icon eq "thumbdown") { $ic3 = " selected"; }
	elsif($icon eq "exclamation") { $ic4 = " selected"; }
	elsif($icon eq "question") { $ic5 = " selected"; }
	elsif($icon eq "lamp") { $ic6 = " selected"; }
	elsif($icon eq "smiley") { $ic7 = " selected"; }
	elsif($icon eq "angry") { $ic8 = " selected"; }
	elsif($icon eq "cheesy") { $ic9 = " selected"; }
	elsif($icon eq "laugh") { $ic10 = " selected"; }
	elsif($icon eq "sad") { $ic11 = " selected"; }
	elsif($icon eq "wink") { $ic12 = " selected"; }

	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></td>
      </tr>~ : qq~~;
	if ($FORM{'notify'} eq "x") {$notify = " checked";}
	if ($FORM{'ns'} eq 'NS') {$nscheck = " checked";}

	if ($username eq 'Guest') {
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("202 $txt{'106'}: $txt{'23'} memberlist.txt");
		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'100'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'100'}); }
		}
		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("203 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("204 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) {
			chomp $reservecfg[$a];
		}
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;
		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
	}
	&wrap;
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	if( $FORM{'waction'} eq 'previewmodify' ) {
		$submittxt = "$txt{'10'}";
		$waction = "postmodify";
		$post = "postmodify";
		$preview = "previewmodify";
		$destination = 'modify2';
		$submittxt = $txt{'10'};
	}
	elsif( $FORM{'waction'} eq 'previewim' ) {
		$submittxt = "$txt{'148'}";
		$destination = "imsend2";
		$waction = "imsend";
		$post = "imsend";
		$preview = "previewim";
		$submittxt = $txt{'148'};
	}
	else {
		$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;
		$destination = 'post2';
		$submittxt = $txt{'105'};
		$waction = "post";
		$post = "post";
		$preview = "preview";
	}

	&LoadCensorList;	# Load Censor List
	$csubject =~ s/\Q$tmpa\E/$tmpb/gi;
	$message =~ s/\Q$tmpa\E/$tmpb/gi;

	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript" src="$ubbcjspath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}">
    <img src="$imagesdir/$icon.gif" name="icons" border=0> $csubject</font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><BR>$message<BR><BR></font></td>
  </tr>
</table>
<BR>
~;
	$message = $mess;
	$yytitle = "$txt{'507'} - $csubject";
	$settofield="message";
	&Postpage;
	&template;
	exit;
}

sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# If poster is a Guest then evaluate the legality of name and email
	if(!$settings[2]) {
		$FORM{'name'} =~ s/\A\s+//;
		$FORM{'name'} =~ s/\s+\Z//;
		&fatal_error($txt{'75'}) unless ($FORM{'name'} ne '' && $FORM{'name'} ne '_' && $FORM{'name'} ne ' ');
		&fatal_error($txt{'568'}) if(length($FORM{'name'}) > 25);
		&fatal_error("$txt{'76'}") if($FORM{'email'} eq '');
		&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($FORM{'email'} !~ /^[0-9A-Za-z@\._\-]+$/);
		&fatal_error("$txt{'500'}") if(($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	}

	# Get the form values
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$subject = $FORM{'subject'};
	$summary = $FORM{'summary'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	if( $threadid =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$notify = $FORM{'notify'};

	if($name && $email) {
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		$tempname = $name;	# hold it temporarily so we can put the _'s back later
		$name =~ s/\_/ /g;
	}

	&fatal_error($txt{'75'}) unless($username || $name);
	&fatal_error($txt{'76'}) unless($settings[2] || $email);
	($xmessage, $xsubject) = &format_extra;
	$message = $xmessage.$message;
	$subject = $xsubject.$subject;
	$pollthread = $FORM{'pollthread'} || 0;
	if ($pollthread != 2) {	# If user is NOT adding a Poll to an existing thread
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
	&fatal_error($txt{'78'}) unless($message);
	if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }

	if( $FORM{'waction'} =~ 'preview' ) { &Preview; }
	&spam_protection;

	if (length($subject) > 50) { $subject = substr($subject,0,50); }
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($subject);
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br>~g;
	if (length($summary) > $MaxSumLen) { $summary = substr($summary,0,$MaxSumLen); }
	&ToHTML($summary);
	$summary =~ s~\n~<br>~g;
	&CheckIcon;

	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

	} # end if


	if ($username ne 'Guest') {
		# If not guest, get name and email.
		$name = $settings[1];
		$email = $settings[2];
	} else {
		# If user is Guest, then make sure the chosen name
		# is not reserved or used by a member.
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("206 $txt{'106'}: $txt{'23'} $memberlist.txt");

		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'473'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'473'}); }
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("207 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("208 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
		$name = $tempname; # put the name back (with any _'s) now that we've checked it
	}


## [Poll Mod] ##
	my @poll_data;
	if ($pollthread) {	
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		$numcount = 0;
		if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($FORM{"question"});
		$guest_vote = $FORM{'guest_vote'} || 0;
		$hide_results = $FORM{'hide_results'} || 0;
		$multi_choice = $FORM{'multi_choice'} || 0;
		$poll_comment = $FORM{'poll_comment'} || "";
		if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($poll_comment);
		$poll_comment =~ s~\n~<br>~g;
		$poll_comment =~ s~\r~~g;
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment\n~;

		for ($i = 1; $i <= $numpolloptions; $i++){
			if ($FORM{"option$i"}) {
				if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
				&ToHTML($FORM{"option$i"});
				$numcount++;
				push @poll_data, qq~0|$FORM{"option$i"}\n~;
			}
		}
		unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
		if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }
	}
## [/Poll Mod] ##


######################################
## DaveB's File Attachment Mod v2.3 ##
######################################

if ($FORM{'file'}) {
if ($FORM{'waction'} ne 'post') { &write_error("$fatxt{'49'}"); }
$mylimit = 1024 * $limit;
$mydirlimit = 1024 * $dirlimit;

$file = $filename;
$file =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
$file =~ s/[#%+,\/:?"<>'|@^]//g;	#edit in between [ ] to include characters you dont want to allow in filenames (dont put a . there or you wont be able to get any file extensions).
$file =~ s/ /_/g;			#replaces spaces in filenames with a "_" character.

opendir(AMD, $upload_dir) || &write_error("$fatxt{'19'} $upload_dir.");
@dirlist = readdir(AMD);
closedir(AMD);

foreach $dirlist(@dirlist)
   {
          if ($dirlist eq $file) { &write_error("$fatxt{'8'}"); }

   }

if ($checkext == 0) { $match = 1; } else {
foreach $ext (@ext){
	chomp ($ext);
		if (grep /$ext$/i,$file){$match=1; last;}
	}
}
if ($match) {
	if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) { 
		$upload_okay = 1;
	}
} else {
		&write_error("$fatxt{'20'} @ext"); 
	}

if ($mydirlimit > 0) {
	&dirstats;
}

$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
$filesizekb = int ($filesize/1024);
if ($filesize > $mylimit && $mylimit != 0) {
	$filesizediff = $filesizekb - $limit;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'21'} $filesizediff $sizevar $fatxt{'21b'}");
} elsif ($filesize > $spaceleft && $mydirlimit != 0) {	
	$filesizediff = $filesizekb - $kbspaceleft;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'22'} $filesizediff $sizevar $fatxt{'22b'}");
}

$write_file = "$upload_dir/$file";
$save_file = "$http_dir/$file"; 

}

#######################################
## /DaveB's File Attachment Mod v2.3 ##
#######################################	

	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
	if($threadid eq '') {
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid="$newthreadid$i";
		}
	}
	else { $newthreadid = ''; }

	if($newthreadid) {
		# This is a new thread. Save it.
		fopen(FILE, "+<$boardsdir/$currentboard.txt") || &write_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		fopen(TEMP, "+>$boardsdir/$currentboard.txt.temp") || &fatal_error("209 $txt{'106'}: $txt{'23'} $boardsdir/$currentboard.txt.temp");
		while( read(FILE,$buffer,1024) ) { print TEMP $buffer; }
		seek TEMP, 0, 0;
		truncate FILE, 0;
		seek FILE, 0, 0;
		print FILE qq~$newthreadid|$subject|$name|$email|$date|0|$username|$icon|0|$summary\n~;
		while( read(TEMP,$buffer,1024) ) { print FILE $buffer; }
		fclose(TEMP);
		if (-e "$boardsdir/$currentboard.txt.temp") { unlink("$boardsdir/$currentboard.txt.temp"); }
		fclose(FILE);
		fopen(FILE, ">$datadir/$newthreadid.txt") || &write_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		$mreplies = 0;
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$newthreadid|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}
		if ($pollthread) { # Save Poll data for new thread
			fopen (POLL, ">$datadir/$newthreadid.poll");
			print POLL @poll_data;
			fclose (POLL);
		}
	} else {
		# This is an old thread. Save it.
		if ($pollthread) { # Save new Poll data
			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @poll_data;
			fclose (POLL);
			$yySetLocation = qq~$cgi;action=display;num=$threadid~;
			&redirectexit;
		} else { # or save new reply data
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msummary) = split(/\|/,$yyThreadLine);
		if( $mstate == 1 ) { &fatal_error($txt{'90'}); }
		++$mreplies;
		fopen(FILE, "+<$boardsdir/$currentboard.txt") || &write_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		fopen(TEMP, "+>$boardsdir/$currentboard.txt.temp") || &fatal_error("209 $txt{'106'}: $txt{'23'} $boardsdir/$currentboard.txt.temp");
		seek TEMP, 0, 0;
		while( read(FILE,$buffer,1024) ) {
			print TEMP $buffer;
		}
		truncate FILE, 0;
		seek FILE, 0, 0;
		print FILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate|$msummary\n~;
		seek TEMP, 0, 0;
		my $new_count = 0;
		while( $line = <TEMP> ) {
			unless($new_count == $yyThreadPosition) { print FILE $line; }
			$new_count++;
		}
		fclose(TEMP);
		if (-e "$boardsdir/$currentboard.txt.temp") { unlink("$boardsdir/$currentboard.txt.temp"); }
		fclose(FILE);
		fopen(FILE, ">>$datadir/$threadid.txt") || &write_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$mnum|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}

		} # end else

	}

	if($username ne 'Guest') {
		# Increment post count for the member.
		$settings[6] =~ s/[\n\r]//g;
		++$settings[6];
		fopen(FILE, ">$memberdir/$username.dat") || &fatal_error("213 $txt{'106'}: $txt{'23'} $username.dat");
		foreach (@settings) {
			print FILE qq~$_\n~;
		}
		fclose(FILE);
	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $newthreadid || $threadid;

	# Update totals for this board.
	&doaddition;

	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }

	# Mark thread as read for the member.
	&dumplog($currentboard,$date);


######################################
## DaveB's File Attachment Mod v2.3 ##
######################################
if ($upload_okay == 1) {
	if($servertype == 0) {
		fopen(AMT, ">$write_file")||&write_error("$fatxt{'19'} $write_file. $!");
		binmode AMT;
		# binmode is for windows only. Ignored by unix
		while ($bytesread=read($filename,$buffer,1024)) { print AMT $buffer; }
		fclose(AMT);	
		chmod (0666, "$write_file");
		close($filename);
		1;
	} elsif ($servertype == 1) {
		close($filename);
		rename $tmpfile, $write_file || &write_error("Error renaming '$tmpfile' to '$write_file'!");
		1;
	}
&clear_temp;
}
#######################################
## /DaveB's File Attachment Mod v2.3 ##
#######################################

	# Let's figure out what page number to show
	$start = 0;
	$pageindex = int($mreplies / $maxmessagedisplay);
	$start = $pageindex * $maxmessagedisplay;

	if($notify) {
		$INFO{'thread'} = $thread;
		$INFO{'start'} = $start;
		require "$sourcedir/Notify.pl";
		&Notify2;
	}
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

sub NotifyUsers {
	$subject = $FORM{'subject'};

	fopen(FILE, "$datadir/$thread.mail") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	foreach $curmail (@mails) {
		chomp $curmail;
		if ($curmail ne $settings[2]) {
			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
		}
	}
	return 1;
}

sub doshowthread {
	my( $line, $trash, $tempname, $tempdate, $temppost );

	&LoadCensorList;	# Load Censor List

	if (@messages) {
		$yymain .= qq~
	<BR><BR>
	<table cellspacing=1 cellpadding=0 width="90%" align="center" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr><td>
	<table class="windowbg" cellspacing=1 cellpadding=2 width=100% align=center bgcolor="$color{'windowbg'}">
	<tr><td class="titlebg" bgcolor="$color{'titlebg'}" colspan=2><font size=2 class="text1" color="$color{'titletext'}">
	<b>$txt{'468'}</b>
	</td></tr>~;
		foreach $line (@messages) { #start for each

			($trash, $tempname, $trash, $tempdate, $trash, $trash, $trash, $trash, $message, $ns) = split(/\|/,$line);
			$tempdate = &timeformat($tempdate);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$message =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			my @words = split(/\s/,$message);
			&wrap;
			$displayname = $tempname;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			$yymain .= qq~

<tr><td align=left class="catbg">
<font size="1">$txt{'279'}: $tempname</font></td>
<td class="catbg" align=right>
<font size="1">$txt{'280'}: $tempdate</font></td>
</tr>
<tr><td class="windowbg2" colspan=2 bgcolor="$color{'windowbg2'}">
<font size="1">$message</font>
</td></tr>~;
		}
		$yymain .= "</table></td></tr></table>\n";
	}
	else { $yymain .= "<!--no summary-->"; }
}

sub doaddition {
	fopen(FILE, "+>$boardsdir/$currentboard.poster");
	print FILE $name;
	fclose(FILE);

	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	fclose(FILE2);

	($views, $lastposter) = split(/\|/,$tempinfo);

	my( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = &BoardCountGet($currentboard);
	++$messagecount;
	unless( $FORM{'threadid'} ) {
		++$threadcount;
	}
	$myname = $username eq 'Guest' ? qq~Guest-$name~ : $username;
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $date, $myname, $thread );

	fopen(FILE2, "+>$datadir/$thread.data");
	print FILE2 "$views|$myname";
	fclose(FILE2);
}


sub format_extra{
	my $threadid = $FORM{'threadid'} || '';
	my ($xmessage, $xheader, $xblock, $xsimple, $xsubject) = "";

	if (-e("$boardsdir/$currentboard.xtra")) {
		require "$boardsdir/$currentboard.xtra";
		@xoptions = split(/\|/, $xtraopts);
		$caption[0] = $xtraheadings; $field[0] = $xoptions[$FORM{"field0"}];
		@xoptions = split(/\|/, $xtraopt);
		$caption[1] = $xtraheading; $field[1] = $xoptions[$FORM{"field1"}];
		@xfields = split(/\|/, $xtrafield);
		$count = 1;
		if ($xtrafield ne "") {
			foreach $xtmp (@xfields) {
				$count++;
				$caption[$count] = $xtmp; $field[$count] = $FORM{"field$count"};
			}
		}
		for( $i = 0; $i <= $count; $i++ ) {
			&FromHTML($caption[$i]);
			$caption[$i] =~ s/&#36;/\$/g;
			$caption[$i] =~ s/&#64;/\@/g;
		}
		&FromHTML($field[0]); $field[0] =~ s/&#36;/\$/g; $field[0] =~ s/&#64;/\@/g;
		&FromHTML($field[1]); $field[1] =~ s/&#36;/\$/g; $field[1] =~ s/&#64;/\@/g;
	}

	if ($xtraformat ne '0' && ($xtrareply eq '1' || ($xtrareply eq '0' && $threadid eq ''))) {

		# define [header], [block] and [simple]
		if ($xtraopt ne "") {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[1] ne "") {
				if ($xtraformat eq "1") {$xheader .= qq~$caption[1]: $field[1]\n~;} else {$xheader .= qq~\[center\] \[b\]\[size=3\] $field[1] \[\/size\]\[\/b\] \[\/center\]~;} 
			}
		}
		if ($xtrafield ne "") {
			for( $i = 2; $i <= $count; $i++ ) {
				if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
					$xblock .= qq~\[tr\]\[td\]\[size=2\] $caption[$i]: \[\/size\]\[\/td\]\[td\]\[b\]\[size=2\] $field[$i] \[\/size\]\[\/b\]\[\/td\]\[\/tr\]~;
					$xsimple .= qq~$caption[$i]: $field[$i]\n~;
				}
			}
			if ($xblock ne "") {$xblock = qq~\[table\] $xblock \[tr\]\[td\] \[\/td\]\[td\] \[\/td\]\[\/tr\] [\/table\]~;}
		}

		# define xmessage based on template
		if ($xtraformat eq "2") {$xmessage = qq~[header][block]~;} # Advanced format
		elsif ($xtraformat eq "3" && $xtratemplate ne "") { # Custom Format
			$xtratemplate =~ s/\|/\n/g;
			&FromHTML($xtratemplate);
			$xtratemplate =~ s/&#36;/\$/g;
			$xtratemplate =~ s/&#64;/\@/g;
			$xmessage = $xtratemplate;
		} else {$xmessage = qq~[header][simple]~;} # Simple format

		for( $i = 0; $i <= $count; $i++ ) {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
				$xmessage =~ s/\[caption$i\]/$caption[$i]/isg;
				$xmessage =~ s/\[field$i\]/$field[$i]/isg;
				$xmessage =~ s~\[if$i\](.*?)\[\/if$i\]~$1~isg;
			} else {
				$xmessage =~ s/\[caption$i\]//isg;
				$xmessage =~ s/\[field$i\]//isg;
				$xmessage =~ s~\[if$i\](.*?)\[\/if$i\]~~isg;
			}
		}	
		$xmessage =~ s/\[block\]/$xblock/isg;
		$xmessage =~ s/\[simple\]/$xsimple/isg;
		$xmessage =~ s/\[header\]/$xheader/isg;
		if ($xmessage ne "") {$xmessage .= qq~\n~;}
	}

	if ($xtraformats ne '0' && $threadid eq '') {

		# define xsubject based on template
		if ($xtraformats eq "2" && $xtratemplates ne "") { # Custom Format
			&FromHTML($xtratemplates);
			$xtratemplates =~ s/&#36;/\$/g;
			$xtratemplates =~ s/&#64;/\@/g;
			$xsubject = $xtratemplates;
		} else {$xsubject = qq~[field0][if0] [/if0]~;} # Simple format

		for( $i = 0; $i <= $count; $i++ ) {
			if ($xtrahide eq "0" || $xtrahide eq "1" && $field[$i] ne "") {
				$xsubject =~ s/\[caption$i\]/$caption[$i]/isg;
				$xsubject =~ s/\[field$i\]/$field[$i]/isg;
				$xsubject =~ s~\[if$i\](.*?)\[\/if$i\]~$1~isg;
			} else {
				$xsubject =~ s/\[caption$i\]//isg;
				$xsubject =~ s/\[field$i\]//isg;
				$xsubject =~ s~\[if$i\](.*?)\[\/if$i\]~~isg;
			}
		}	
	}
	return ($xmessage, $xsubject);
}

1;
